unit hiMT_MultiMem;

interface

uses Kol,Share,Debug;

type
  THIMT_MultiMem = class(TDebug)
   private
    l: array of PData;
    FData: TData;
    procedure SetCount(value:word);
   public
    _prop_From:Integer;
    _event_onData:THI_Event;
    _data_Data:THI_Event;
    
    destructor Destroy; override;
    procedure _work_doValue(var _Data:TData; Index:word);
    procedure _work_doClear(var _Data:TData; Index:word);
    procedure Value(var _Data:TData; Index:word);
    property _prop_Count:word write SetCount;
  end;

implementation

procedure THIMT_MultiMem.SetCount;
begin
  SetLength(l,Value);
end;

procedure THIMT_MultiMem._work_doValue;
var i:integer;
    p:PData;
begin
  FreeData(@FData);
  FData := ReadMTData(_data,_data_Data,@FData);
  CopyData(@FData,@FData);
  p:=@FData;   
  for i:=0 to High(l) +_prop_From do begin
     if i>=_prop_From then l[i-_prop_From]:=p; 
     if assigned(p.ldata) then p:=p.ldata 
                          else p:=@_Data_Empty;
  end;
  _hi_CreateEvent(_Data,@_event_onData,FData);
end;

procedure THIMT_MultiMem._work_doClear;
begin
  FreeData(@FData);
  dtNull(FData);
  _hi_CreateEvent(_Data,@_event_onData);
end;

procedure THIMT_MultiMem.Value;
begin
  dtData(_data, l[index]^);
end;

destructor THIMT_MultiMem.Destroy;
begin
  FreeData(@FData);
  inherited;
end;

end.
